// C Source File
// Created 11/2/2001; 11:25:34 AM
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h> 				// Include All Header Files

#define fatal(s) ST_helpMsg (s); return;
int _ti89;                  // Produce .89Z File
int _ti92plus;              // Produce .9XZ File

void DrawStrHCenter (char *text, int y);

enum {FAHRENHEIT = 1, CELSIUS};

// Main Function
void _main (void)
{
	char inputstring[10] = {};
	HANDLE dialoghandle, popuphandle;
	ESI topest;
	int flag, width, top, bottom, top2, bottom2;
	FontSetSys (F_4x6);
	WinClr (DeskTop);
	if (!(popuphandle = PopupNew ("Which one?", 0)))
	{
		fatal ("Can't create Popup Menu")
	}
	PopupAddText (popuphandle, -1, "Fahrenheit", FAHRENHEIT);//handle, link, text, retval
	PopupAddText (popuphandle, -1, "Celsius", CELSIUS);
	DrawStrHCenter ("What do you want to convert to?", 20);
	if (!(flag = PopupDo (popuphandle, CENTER, 30, 0)))
	{
		return;
	}
	if (!(dialoghandle = DialogNewSimple (140, 35)))
	{
		HeapFree (popuphandle);
		fatal ("Can't Create Dialog Box")
	}
	DialogAddRequest (dialoghandle, 2, 15, "Enter Temperature", 0, 10, 10);
	//handle, x, y, prompt, offset, maxlen, width
	DialogAddTitle (dialoghandle, "Enter Temperature", BT_OK, BT_CANCEL);
	WinClr (DeskTop);
	if (DialogDo (dialoghandle, CENTER, CENTER, inputstring, NULL) != KEY_ENTER)
	{
		HeapFree (dialoghandle);
		HeapFree (popuphandle);
		return;
	}
	push_parse_text (inputstring);
	if (flag == CELSIUS)
	{
		push_longint (32);
		push_quantum (SUB_TAG);
		push_Float (1.8);
		push_quantum (DIV_TAG);
	}
	else if (flag == FAHRENHEIT)
	{
		push_Float (1.8);
		push_quantum (MUL_TAG);
		push_longint (32);
		push_quantum (ADD_TAG);
	}
	topest = top_estack;
	NG_rationalESI (top_estack);
	WinClr (DeskTop);
	Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom, &top);
	Print2DExpr (top_estack, DeskTop, (LCD_WIDTH - width)/2, 20 + top);
	NG_approxESI (topest);
	Parms2D (Parse2DExpr (top_estack, TRUE), &width, &bottom2, &top2);
	Print2DExpr (top_estack, DeskTop, (LCD_WIDTH - width)/2,
		30 + top + bottom + top2);
	ngetchx();
	HeapFree (dialoghandle);
	HeapFree (popuphandle);
}

void DrawStrHCenter (char *title, int y)
{
	DrawStr ((LCD_WIDTH - DrawStrWidth (title, F_4x6))/2, y, title, A_NORMAL);
}
